package provide [file tail [info script]] 1

# get the contents found between tags in an sgml document
# even if the tags are inside a comment
proc getTaggedText {tag html {attr {}}} \
{
	regsub -all "\\?" $attr "\\?" attr
	regsub -all "$tag" $html "\b$tag" html
	set tag "\b$tag"
	set text ""
	set w " \t\r\n"					;# white space
	set exp <$tag+$attr>\[$w]*(\[^\b]*)\[$w]*</$tag>
	regexp -nocase $exp $html tag text
	# strip whitespace
	string trim $text
}

# get all the contents found between tags in an sgml document
# even if the tags are inside a comment
# return a list
proc getAllTaggedText {tag html {attr {}}} \
{
	regsub -all "\\?" $attr "\\?" attr
	regsub -all "$tag" $html "\b$tag" html
	set tag "\b$tag"
	set text ""
	set w " \t\r\n"					;# white space
	set exp <$tag+$attr>\[$w]*(\[^\b]*)\[$w]*</$tag>
	set text [regexp -nocase -all -inline $exp $html]
	# strip whitespace
	set theList [string trim $text]
	set length [llength $theList]
	set count 1
	set matches ""
	while {$count < $length} \
	{
		lappend matches [lindex $theList $count]
		incr count 2
	}
	
	return $matches
}
