// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

#define MAX_REGISTERS				10				// maximum number of registers that will be remembered

typedef struct compiledExpression COMPILED_EXPRESSION;

void REFree(COMPILED_EXPRESSION *theExpression);
void REPrintCompiledExpression(COMPILED_EXPRESSION *theExpression);
COMPILED_EXPRESSION *RECompile(UINT8 *theExpression,UINT32 numBytes,const UINT8 *translateTable);
bool GetRERegisterMatch(COMPILED_EXPRESSION *theCompiledExpression,UINT32 theRegisterIndex,UINT32 *matchOffset,UINT32 *matchLength);
bool GetRERegisterMatchChunkAndOffset(COMPILED_EXPRESSION *theCompiledExpression,UINT32 theRegisterIndex,CHUNK_HEADER **theChunk,UINT32 *theOffset,UINT32 *matchLength);
bool SearchForwardRE(CHUNK_HEADER *theChunk,UINT32 theOffset,COMPILED_EXPRESSION *theCompiledExpression,bool leftEdge,bool rightEdge,UINT32 numToSearchStart,UINT32 numToSearch,bool ignoreCase,bool *foundMatch,UINT32 *matchOffset,UINT32 *numMatched,CHUNK_HEADER **startChunk,UINT32 *startOffset,CHUNK_HEADER **endChunk,UINT32 *endOffset,bool allowAbort);
bool SearchBackwardRE(CHUNK_HEADER *theChunk,UINT32 theOffset,COMPILED_EXPRESSION *theCompiledExpression,bool leftEdge,bool rightEdge,UINT32 numToSearchStart,UINT32 numToSearch,bool ignoreCase,bool *foundMatch,UINT32 *matchOffset,UINT32 *numMatched,CHUNK_HEADER **startChunk,UINT32 *startOffset,CHUNK_HEADER **endChunk,UINT32 *endOffset,bool allowAbort);
void REHuntBackToFarthestPossibleStart(CHUNK_HEADER *theChunk,UINT32 theOffset,COMPILED_EXPRESSION *theCompiledExpression,UINT32 *numBack,CHUNK_HEADER **endChunk,UINT32 *endOffset);
