// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


void DeleteAllSelections(SELECTION_UNIVERSE *theUniverse);
void DeleteSelectionRange(SELECTION_UNIVERSE *theUniverse,UINT32 startPosition,UINT32 numElements);
bool InsertSelectionRange(SELECTION_UNIVERSE *theUniverse,UINT32 startPosition,UINT32 numElements);
bool ClearSelectionRange(SELECTION_UNIVERSE *theUniverse,UINT32 startPosition,UINT32 numElements);
bool SetSelectionRange(SELECTION_UNIVERSE *theUniverse,UINT32 startPosition,UINT32 numElements);
bool GetSelectionAtOrAfterPosition(SELECTION_UNIVERSE *theUniverse,UINT32 position,UINT32 *startPosition,UINT32 *numElements);
bool GetSelectionAtOrBeforePosition(SELECTION_UNIVERSE *theUniverse,UINT32 position,UINT32 *startPosition,UINT32 *numElements);
bool GetSelectionRange(SELECTION_UNIVERSE *theUniverse,UINT32 position,UINT32 *startPosition,UINT32 *numElements,bool *isActive);
bool GetSelectionAtPosition(SELECTION_UNIVERSE *theUniverse,UINT32 position);
bool IsSelectionEmpty(SELECTION_UNIVERSE *theUniverse);
void GetSelectionEndPositions(SELECTION_UNIVERSE *theUniverse,UINT32 *startPosition,UINT32 *endPosition);
UINT32 GetSelectionCursorPosition(SELECTION_UNIVERSE *theUniverse);
void SetSelectionCursorPosition(SELECTION_UNIVERSE *theUniverse,UINT32 thePosition);
void AdjustSelectionsForChange(SELECTION_UNIVERSE *theUniverse,UINT32 startOffset,UINT32 oldEndOffset,UINT32 newEndOffset);
bool CopySelectionUniverse(SELECTION_UNIVERSE *theSourceUniverse,SELECTION_UNIVERSE *theDestUniverse);
bool OrSelectionUniverse(SELECTION_UNIVERSE *theSourceUniverse,SELECTION_UNIVERSE *theDestUniverse);
bool AndSelectionUniverse(SELECTION_UNIVERSE *theSourceUniverse,SELECTION_UNIVERSE *theDestUniverse);
bool XorSelectionUniverse(SELECTION_UNIVERSE *theSourceUniverse,SELECTION_UNIVERSE *theDestUniverse);
void CloseSelectionUniverse(SELECTION_UNIVERSE *theUniverse);
SELECTION_UNIVERSE *OpenSelectionUniverse();
MARK_VISIBILITY *LocateMarkVisibilityInView(EDITOR_VIEW *view,EDITOR_MARK *mark);
void UnlinkVisibleMarksFromView(EDITOR_VIEW *theView);
void ClearEditorMarkVisible(EDITOR_MARK *mark,EDITOR_VIEW *view);
bool SetEditorMarkVisible(EDITOR_MARK *mark,EDITOR_VIEW *view,EDITOR_COLOR backgroundColor);
EDITOR_MARK *LocateEditorMark(EDITOR_BUFFER *theBuffer,char *markName);
void CloseEditorMark(EDITOR_BUFFER *theBuffer,EDITOR_MARK *theMark);
EDITOR_MARK *NewEditorMark(EDITOR_BUFFER *theBuffer,char *markName);
