// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct expressionPiece EXPRESSION_PIECE;
typedef struct expressionPieceList EXPRESSION_PIECE_LIST;
typedef struct syntaxExpression SYNTAX_EXPRESSION;
typedef struct syntaxStyleMapping SYNTAX_STYLE_MAPPING;
typedef struct syntaxStyleMappingList SYNTAX_STYLE_MAPPING_LIST;
typedef struct syntaxMap SYNTAX_MAP;

bool UpdateSyntaxInformation(EDITOR_BUFFER *theBuffer,UINT32 startOffset,UINT32 endOffset,UINT32 numBytes);
bool RegenerateAllSyntaxInformation(EDITOR_BUFFER *theBuffer);
SYNTAX_MAP *GetInstanceParentMap(SYNTAX_INSTANCE *theInstance);
void CloseSyntaxInstance(SYNTAX_INSTANCE *theInstance);
SYNTAX_INSTANCE *OpenSyntaxInstance(SYNTAX_MAP *theMap,EDITOR_BUFFER *theBuffer);
void RemoveMappingList(SYNTAX_STYLE_MAPPING_LIST *theList);
SYNTAX_STYLE_MAPPING_LIST *AddMappingListElement(SYNTAX_STYLE_MAPPING_LIST **theListHead,SYNTAX_STYLE_MAPPING *theMapping);
SYNTAX_STYLE_MAPPING_LIST *AddBetweenListElementToMapping(SYNTAX_STYLE_MAPPING *theMapping,SYNTAX_STYLE_MAPPING *betweenMapping);
SYNTAX_STYLE_MAPPING_LIST *AddRootListElementToMap(SYNTAX_MAP *theMap,SYNTAX_STYLE_MAPPING *rootMapping);
SYNTAX_STYLE_MAPPING *LocateSyntaxStyleMapping(SYNTAX_MAP *theMap,const char *theName);
void SetMappingStartExpressionPiece(SYNTAX_STYLE_MAPPING *theMapping,EXPRESSION_PIECE *startExpressionPiece);
void RemoveExpressionList(EXPRESSION_PIECE_LIST *theList);
EXPRESSION_PIECE_LIST *AddMappingEndExpressionPiece(SYNTAX_STYLE_MAPPING *theMapping,EXPRESSION_PIECE *endExpressionPiece);
void SetMappingStyles(SYNTAX_STYLE_MAPPING *theMapping,UINT32 startStyle,UINT32 betweenStyle,UINT32 endStyle);
void RemoveMappingFromSyntaxMap(SYNTAX_MAP *theMap,SYNTAX_STYLE_MAPPING *theMapping);
SYNTAX_STYLE_MAPPING *AddMappingToSyntaxMap(SYNTAX_MAP *theMap,const char *mappingName);
EXPRESSION_PIECE *LocateExpressionPiece(SYNTAX_EXPRESSION *theExpression,bool useRegisterMatch,UINT32 registerIndex);
void RemovePieceFromExpression(SYNTAX_EXPRESSION *theExpression,EXPRESSION_PIECE *thePiece);
EXPRESSION_PIECE *AddPieceToExpression(SYNTAX_EXPRESSION *theExpression,bool useRegisterMatch,UINT32 registerIndex);
SYNTAX_EXPRESSION *LocateSyntaxMapExpression(SYNTAX_MAP *theMap,const char *theName);
void RemoveExpressionFromSyntaxMap(SYNTAX_MAP *theMap,SYNTAX_EXPRESSION *theExpression);
SYNTAX_EXPRESSION *AddExpressionToSyntaxMap(SYNTAX_MAP *theMap,const char *expressionName,const char *expressionText);
char *GetSyntaxMapName(SYNTAX_MAP *theMap);
SYNTAX_MAP *LocateNextSyntaxMap(SYNTAX_MAP *theMap);
SYNTAX_MAP *LocateSyntaxMap(char *theName);
void UnlinkSyntaxMap(SYNTAX_MAP *theMap);
bool LinkSyntaxMap(SYNTAX_MAP *theMap);
void CloseSyntaxMap(SYNTAX_MAP *theMap);
SYNTAX_MAP *OpenSyntaxMap(char *theName);
EDITOR_BUFFER *LocateNextEditorBufferOnMap(SYNTAX_MAP *theMap,EDITOR_BUFFER *theBuffer);
SYNTAX_MAP *GetAssignedSyntaxMap(EDITOR_BUFFER *theBuffer);
bool AssignSyntaxMap(EDITOR_BUFFER *theBuffer,SYNTAX_MAP *theMap);
void UnInitSyntaxMaps();
bool InitSyntaxMaps();
