// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


bool UniverseSanityCheck(TEXT_UNIVERSE *theUniverse);
void PositionToChunkPositionPastEnd(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,CHUNK_HEADER **theChunk,UINT32 *theOffset);
void PositionToChunkPosition(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,CHUNK_HEADER **theChunk,UINT32 *theOffset);
void PositionToLinePosition(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,UINT32 *theLine,UINT32 *theLineOffset,CHUNK_HEADER **theChunk,UINT32 *theChunkOffset);
void LineToChunkPosition(TEXT_UNIVERSE *theUniverse,UINT32 theLine,CHUNK_HEADER **theChunk,UINT32 *theOffset,UINT32 *thePosition);
void AddToChunkPosition(TEXT_UNIVERSE *theUniverse,CHUNK_HEADER *theChunk,UINT32 theOffset,CHUNK_HEADER **newChunk,UINT32 *newOffset,UINT32 distanceToMove);
void ChunkPositionToNextLine(TEXT_UNIVERSE *theUniverse,CHUNK_HEADER *theChunk,UINT32 theOffset,CHUNK_HEADER **newChunk,UINT32 *newOffset,UINT32 *distanceMoved);
bool InsertUniverseChunks(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,CHUNK_HEADER *textChunk,UINT32 textOffset,UINT32 numBytes);
bool InsertUniverseText(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,UINT8 *theText,UINT32 numBytes);
bool ExtractUniverseText(TEXT_UNIVERSE *theUniverse,CHUNK_HEADER *theChunk,UINT32 theOffset,UINT8 *theText,UINT32 numBytes,CHUNK_HEADER **nextChunk,UINT32 *nextOffset);
bool DeleteUniverseText(TEXT_UNIVERSE *theUniverse,UINT32 thePosition,UINT32 numBytes);
TEXT_UNIVERSE *OpenTextUniverse();
void CloseTextUniverse(TEXT_UNIVERSE *theUniverse);
