// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


#define	EDIT_MIN_WIDTH			100
#define	EDIT_MAX_WIDTH			((1<<30)-1)
#define	EDIT_MIN_HEIGHT			100
#define	EDIT_MAX_HEIGHT			((1<<30)-1)

#define	H_SCROLL_MAX_WIDTH		32767	// maximum width handled by the horizontal scroll bar

#define EDIT_TOP_BORDER			0		// the view of an edit window is offset by these borders (strictly for looks)
#define EDIT_BOTTOM_BORDER		0
#define EDIT_LEFT_BORDER		0
#define EDIT_RIGHT_BORDER		0

#define	STATUS_BAR_LINE_HEIGHT	2

void AdjustDocumentWindowStatus(EDITOR_WINDOW *theWindow);
void UpdateDocumentWindow(EDITOR_WINDOW *theWindow);
void AdjustDocumentWindowForNewSize(EDITOR_WINDOW *theWindow);
void DocumentWindowButtonPress(EDITOR_WINDOW *theWindow,XEvent *theEvent);
void DocumentPeriodicProc(EDITOR_WINDOW *theWindow);
void DocumentWindowEvent(EDITOR_WINDOW *theWindow,XEvent *theEvent);
void ScrollEditViewEvent(EDITOR_VIEW *theView,UINT32 eventCode,bool repeating);
void MinimizeDocumentWindow(EDITOR_WINDOW *theWindow);
void UnminimizeDocumentWindow(EDITOR_WINDOW *theWindow);
void SetTopDocumentWindow(EDITOR_WINDOW *theWindow);
EDITOR_WINDOW *GetActiveDocumentWindow();
EDITOR_WINDOW *GetTopDocumentWindow();
bool GetSortedDocumentWindowList(UINT32 *numElements,EDITOR_WINDOW ***theList);
EDITOR_VIEW *GetDocumentWindowCurrentView(EDITOR_WINDOW *theWindow);
bool GetDocumentWindowTitle(EDITOR_WINDOW *theWindow,char *theTitle,UINT32 stringBytes);
bool SetDocumentWindowTitle(EDITOR_WINDOW *theWindow,char *theTitle);
bool GetEditorDocumentWindowForegroundColor(EDITOR_WINDOW *theWindow,EDITOR_COLOR *foregroundColor);
bool SetEditorDocumentWindowForegroundColor(EDITOR_WINDOW *theWindow,EDITOR_COLOR foregroundColor);
bool GetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW *theWindow,EDITOR_COLOR *backgroundColor);
bool SetEditorDocumentWindowBackgroundColor(EDITOR_WINDOW *theWindow,EDITOR_COLOR backgroundColor);
bool GetEditorDocumentWindowRect(EDITOR_WINDOW *theWindow,EDITOR_RECT *theRect);
bool SetEditorDocumentWindowRect(EDITOR_WINDOW *theWindow,EDITOR_RECT *theRect);
EDITOR_WINDOW *OpenDocumentWindow(EDITOR_BUFFER *theBuffer,EDITOR_RECT *theRect,char *theTitle,char *fontName,UINT32 tabSize,EDITOR_COLOR foreground,EDITOR_COLOR background);
void CloseDocumentWindow(EDITOR_WINDOW *theWindow);
