// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".


// defines and data structures for static text

#define	MAXSTATIC_TEXTSTRING	512

typedef struct staticText
{
	EDITOR_WINDOW
		*parentWindow;											// the window that contains this text
	EDITOR_COLOR
		backgroundColor,										// color to use when drawing background
		foregroundColor;										// color to use when drawing foreground
	EDITOR_RECT
		theRect;
	EDITOR_FONT
		*theFont;												// info about currently selected font
	char
		theString[MAXSTATIC_TEXTSTRING];
} STATIC_TEXT;

typedef struct staticTextDescriptor								// describes static text to creation routines
{
	EDITOR_RECT
		theRect;
	EDITOR_COLOR
		backgroundColor;										// color to use when drawing background
	EDITOR_COLOR
		foregroundColor;										// color to use when drawing foreground
	const char
		*theString;
	const char
		*fontName;
} STATIC_TEXT_DESCRIPTOR;

void ResetStaticTextItemText(DIALOG_ITEM *theItem,char *newString);
bool CreateStaticTextItem(DIALOG_ITEM *theItem,void *theDescription);
